#include<iostream>
#include<cstring>
#include<cstdlib>
using namespace std;

void nemoguce();
int main()
{
	string  grupa1;
	int zalihe[4],i,potreba[100],N,uk,dodeljeno[100][100],v;
	cout<<"Broj pacijenata: ";
	cin>>N;
	cout<<endl;
	cout<<"Zalihe: "<<endl;
	for(i=0;i<4;i++)
		cin>>zalihe[i];
	cout<<"Potrebe: "<<endl;
	for(i=0;i<N;i++){
		cin>>grupa1[i]>>potreba[i];
		}
	for(i=0;i<N;i++)
		switch(grupa1[i]){
			case 'O':
				if(zalihe[0]>=potreba[i]){
					zalihe[0]-=potreba[i];
					dodeljeno[i][0]=potreba[i];
				}else
					nemoguce();
				break;
			case 'A':
				if(zalihe[1]>=potreba[i]){
					dodeljeno[i][1]=potreba[i];
					zalihe[1]-=potreba[i];
				}else{
					if(zalihe[0]+zalihe[1]>=potreba[i]){
						dodeljeno[i][0]=potreba[i]-zalihe[1];
						dodeljeno[i][1]=zalihe[1];
						potreba[i]-=zalihe[1];
						zalihe[0]-=potreba[i];
						zalihe[1]=0;
					}else
						nemoguce();
				}
				break;
				case 'B':
					if(zalihe[2]>=potreba[i]){
						dodeljeno[i][2]=potreba[i];
						zalihe[2]-=potreba[i];
					}else{
						if(zalihe[2]+zalihe[0]>=potreba[i]){
							dodeljeno[i][0]=potreba[i]-zalihe[2];
							dodeljeno[i][2]=potreba[i]-zalihe[0];
							potreba[i]-=zalihe[2];
							zalihe[0]-=potreba[i];
						}else
							nemoguce();
					}
					break;
				default:
					cout<<"Trenutno ne podrzavamo AB grupu :)"<<endl;
					exit(EXIT_SUCCESS);
		}
	system("cls");	
	cout<<"Moguce"<<endl;
	for(i=0;i<N;i++){
		cout<<endl;
		for(int j=0;j<4;j++)
			cout<<dodeljeno[i][j];
		}
			
	return 0;
}

void nemoguce()
{
	system("cls");
	cout<<"nemoguce"<<endl;
	exit(EXIT_SUCCESS);
 }